<!--
    Copyright © 2016 - 2020 Stefan Berg <isbeorn86+NINA@googlemail.com> and the N.I.N.A. contributors

    This file is part of N.I.N.A. - Nighttime Imaging 'N' Astronomy.

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.-->
<UserControl
    x:Class="NINA.View.AnchorableGuiderView"
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
    xmlns:enum="clr-namespace:NINA.Utility.Enum"
    xmlns:local="clr-namespace:NINA.View"
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    xmlns:ns="clr-namespace:NINA.Locale"
    xmlns:oxy="clr-namespace:OxyPlot.Wpf;assembly=OxyPlot.Wpf"
    xmlns:util="clr-namespace:NINA.Utility"
    d:DesignHeight="300"
    d:DesignWidth="300"
    mc:Ignorable="d">
    <ScrollViewer VerticalScrollBarVisibility="Auto">
        <Grid>
            <Grid.RowDefinitions>
                <RowDefinition Height="Auto" />
                <RowDefinition />
            </Grid.RowDefinitions>
            <WrapPanel Margin="1,5,0,0">
                <StackPanel Height="25" Orientation="Horizontal">
                    <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblState}" />
                    <TextBlock VerticalAlignment="Center" Text=": " />
                    <TextBlock VerticalAlignment="Center" Text="{Binding Guider.State}" />
                </StackPanel>
                <Border Height="25" BorderBrush="{x:Null}">
                    <TextBlock
                        Margin="5,0,0,0"
                        VerticalAlignment="Center"
                        Text="{Binding GuideStepsHistory.RMS.RAText}" />
                </Border>
                <Border Height="25" BorderBrush="{x:Null}">
                    <TextBlock
                        Margin="5,0,0,0"
                        VerticalAlignment="Center"
                        Text="{Binding GuideStepsHistory.RMS.DecText}" />
                </Border>
                <Border Height="25" BorderBrush="{x:Null}">
                    <TextBlock
                        Margin="5,0,0,0"
                        VerticalAlignment="Center"
                        Text="{Binding GuideStepsHistory.RMS.TotalText}" />
                </Border>

                <ComboBox
                    Height="25"
                    MinWidth="0"
                    MinHeight="0"
                    Margin="5,0,0,0"
                    DataContext="{Binding GuideStepsHistory}"
                    ItemStringFormat="y: +/-{0}&quot;"
                    SelectedValue="{Binding Source={StaticResource AppVM}, Path=GuiderVM.GuiderMaxY}"
                    SelectedValuePath="Content">
                    <ComboBoxItem>0.25</ComboBoxItem>
                    <ComboBoxItem>0.5</ComboBoxItem>
                    <ComboBoxItem>1</ComboBoxItem>
                    <ComboBoxItem>2</ComboBoxItem>
                    <ComboBoxItem>4</ComboBoxItem>
                    <ComboBoxItem>8</ComboBoxItem>
                    <ComboBoxItem>16</ComboBoxItem>
                    <ComboBoxItem>32</ComboBoxItem>
                    <ComboBoxItem>64</ComboBoxItem>
                </ComboBox>
                <!--<TextBlock Text="{ns:Loc LblXAxisScale}" />-->
                <ComboBox
                    Height="25"
                    MinWidth="0"
                    MinHeight="0"
                    Margin="5,0,0,0"
                    DataContext="{Binding GuideStepsHistory}"
                    ItemStringFormat="x: {0}"
                    SelectedValue="{Binding Source={StaticResource AppVM}, Path=GuiderVM.HistorySize}"
                    SelectedValuePath="Content">
                    <ComboBoxItem>50</ComboBoxItem>
                    <ComboBoxItem>100</ComboBoxItem>
                    <ComboBoxItem>200</ComboBoxItem>
                    <ComboBoxItem>400</ComboBoxItem>
                </ComboBox>
                <!--<TextBlock Text="{ns:Loc LblYAxisUnits}" />-->
                <ComboBox
                    Height="25"
                    MinWidth="0"
                    MinHeight="0"
                    Margin="5,0,0,0"
                    DataContext="{Binding GuideStepsHistory}"
                    ItemStringFormat="unit: {0}"
                    ItemsSource="{Binding Source={util:EnumBindingSource {x:Type enum:GuiderScaleEnum}}}"
                    SelectedItem="{Binding Source={StaticResource AppVM}, Path=GuiderVM.GuiderScale}" />
                <Button
                    Grid.Column="3"
                    Height="25"
                    MinWidth="50"
                    MaxWidth="60"
                    Margin="5,0,0,0"
                    Command="{Binding ClearGraphCommand}">
                    <TextBlock Foreground="{StaticResource ButtonForegroundBrush}" Text="{ns:Loc LblClear}" />
                </Button>
            </WrapPanel>

            <oxy:Plot
                Grid.Row="2"
                Background="{StaticResource BackgroundBrush}"
                DataContext="{Binding GuideStepsHistory}"
                LegendBackground="{Binding Path=Color, Source={StaticResource BackgroundBrush}}"
                LegendBorder="{Binding Path=Color, Source={StaticResource BorderBrush}}"
                LegendFontSize="10"
                LegendMaxHeight="35"
                LegendOrientation="Horizontal"
                LegendPadding="2"
                LegendPlacement="Inside"
                LegendPosition="BottomLeft"
                LegendSymbolLength="10"
                LegendTextColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                PlotAreaBackground="{StaticResource BackgroundBrush}"
                PlotAreaBorderColor="{Binding Path=Color, Source={StaticResource BorderBrush}}">
                <oxy:Plot.Axes>
                    <oxy:LinearAxis
                        Key="DistanceAxis"
                        AxislineColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                        IsPanEnabled="False"
                        IsZoomEnabled="False"
                        MajorGridlineColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}, Converter={StaticResource SetAlphaToColorConverter}, ConverterParameter=100}"
                        MajorGridlineStyle="LongDash"
                        MajorStep="{Binding Interval}"
                        Maximum="{Binding MaxY}"
                        Minimum="{Binding MinY}"
                        Position="Left"
                        TextColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                        TicklineColor="{Binding Path=Color, Source={StaticResource SecondaryBrush}}" />
                    <oxy:LinearAxis
                        Key="DurationAxis"
                        IsAxisVisible="False"
                        IsPanEnabled="False"
                        IsZoomEnabled="False"
                        Maximum="{Binding MaxDurationY}"
                        Minimum="{Binding MinDurationY}"
                        Position="Right" />
                    <oxy:LinearAxis
                        Key="TextAxisX"
                        IsAxisVisible="False"
                        Maximum="1"
                        Minimum="0"
                        Position="Bottom" />
                    <oxy:LinearAxis
                        Key="TextAxisY"
                        IsAxisVisible="False"
                        Maximum="1"
                        Minimum="0"
                        Position="Right" />
                    <oxy:LinearAxis
                        Key="DataAxisX"
                        AbsoluteMinimum="0"
                        IsAxisVisible="False"
                        MinimumRange="{Binding HistorySize}"
                        Position="Bottom" />
                </oxy:Plot.Axes>
                <oxy:Plot.Series>
                    <oxy:LineSeries
                        Title="{ns:Loc LblRA}"
                        DataFieldX="Id"
                        DataFieldY="RADistanceRawDisplay"
                        ItemsSource="{Binding GuideSteps}"
                        XAxisKey="DataAxisX"
                        YAxisKey="DistanceAxis"
                        Color="Blue" />
                    <oxy:LineSeries
                        Title="{ns:Loc LblDec}"
                        DataFieldX="Id"
                        DataFieldY="DECDistanceRawDisplay"
                        ItemsSource="{Binding GuideSteps}"
                        XAxisKey="DataAxisX"
                        YAxisKey="DistanceAxis"
                        Color="Red" />
                    <oxy:LinearBarSeries
                        Title="{ns:Loc LblRACorrections}"
                        BarWidth="3"
                        DataFieldX="IdOffsetLeft"
                        DataFieldY="RADuration"
                        FillColor="Transparent"
                        ItemsSource="{Binding GuideSteps}"
                        StrokeColor="Blue"
                        StrokeThickness="1"
                        XAxisKey="DataAxisX"
                        YAxisKey="DurationAxis"
                        Color="Blue" />
                    <oxy:LinearBarSeries
                        Title="{ns:Loc LblDecCorrections}"
                        BarWidth="3"
                        DataFieldX="IdOffsetRight"
                        DataFieldY="DECDuration"
                        FillColor="Transparent"
                        ItemsSource="{Binding GuideSteps}"
                        StrokeColor="Red"
                        StrokeThickness="1"
                        XAxisKey="DataAxisX"
                        YAxisKey="DurationAxis"
                        Color="Red" />
                    <oxy:LineSeries
                        Title="{ns:Loc LblDither}"
                        DataFieldX="Id"
                        DataFieldY="Dither"
                        ItemsSource="{Binding GuideSteps}"
                        MarkerFill="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                        MarkerSize="5"
                        MarkerType="Triangle"
                        XAxisKey="DataAxisX"
                        YAxisKey="TextAxisY"
                        Color="Transparent" />
                </oxy:Plot.Series>
                <oxy:Plot.Annotations>
                    <oxy:LineAnnotation
                        Text="GuideNorth"
                        TextColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                        TextVerticalAlignment="Top"
                        Type="Horizontal"
                        XAxisKey="TextAxisX"
                        Y="0.99"
                        YAxisKey="TextAxisY"
                        Color="Transparent" />
                    <oxy:LineAnnotation
                        Text="GuideEast"
                        TextColor="{Binding Path=Color, Source={StaticResource PrimaryBrush}}"
                        TextVerticalAlignment="Bottom"
                        Type="Horizontal"
                        XAxisKey="TextAxisX"
                        Y="0.01"
                        YAxisKey="TextAxisY"
                        Color="Transparent" />
                </oxy:Plot.Annotations>
            </oxy:Plot>
        </Grid>
    </ScrollViewer>
</UserControl>